#ifdef CHIP_F169

#define MEMSIZE 60
#define F1xx
#include  <msp430x16x.h>
#endif

#if CHIP_F149
#define  F4xx
#define MEMSIZE 60
#include  <msp430x14x>
#endif

#ifdef CHIP_F439
#define MEMSIZE 60
#define  F4xx
#include  <msp430x43x>
#endif

#ifdef CHIP_F1491
#define MEMSIZE 60
#define F1xx
#include  <msp430x14x1>
#endif

#ifdef CHIP_F449
#define MEMSIZE 60
#define  F4xx
#include  <msp430x44x.h>
#endif

#ifdef CHIP_F1612
#define MEMSIZE 55
#define F1xx
#include  <msp430x16x>
#endif

#ifdef CHIP_FG438
#define MEMSIZE 48
#define  F4xx
#include  <msp430x43x>
#endif

#ifdef CHIP_F168
#define MEMSIZE 48
#define F1xx
#include  <msp430x16x>
#endif

#ifdef CHIP_F448
#define MEMSIZE 48
#define  F4xx
#include  <msp430x44x>
#endif

#ifdef CHIP_F148
#define MEMSIZE 48
#define F1xx
#include  <msp430x14x>
#endif

#ifdef CHIP_F1481
#define MEMSIZE 48
#define F1xx
#include  <msp430x14x1>
#endif

#ifdef CHIP_F1611
#define MEMSIZE 48
#define F1xx
#include  <msp430x16x1>
#endif

#ifdef CHIP_F157
#define MEMSIZE 32
#define F1xx
#include  <msp430x15x>
#endif

#ifdef CHIP_F427
#define MEMSIZE 32
#define  F4xx
#include  <msp430x42x>
#endif

#ifdef CHIP_F167
#define MEMSIZE 32
#define F1xx
#include  <msp430x16x>
#endif

#ifdef CHIP_F147
#define MEMSIZE 32
#define F1xx
#include  <msp430x14x>
#endif

#ifdef CHIP_F447
#define MEMSIZE 32
#define  F4xx
#include  <msp430x44x>
#endif

#ifdef CHIP_FG437
#define MEMSIZE 32
#define  F4xx
#include  <msp430xg43x>
#endif

#ifdef CHIP_F1610
#define MEMSIZE 32
#define F1xx
#include  <msp430x16x>
#endif

#ifdef CHIP_F156
#define MEMSIZE 24
#define F1xx
#include  <msp430x15x>
#endif

#ifdef CHIP_F436
#define MEMSIZE 24
#define  F4xx
#include  <msp430x43x>
#endif

#ifdef CHIP_F135
#define MEMSIZE 16
#define F1xx
#include  <msp430x13x>
#endif

#ifdef CHIP_F425
#define MEMSIZE 16
#define  F4xx
#include  <msp430x42x>
#endif

#ifdef CHIP_F435
#define MEMSIZE 16
#define  F4xx
#include  <msp430x43x>
#endif

#ifdef CHIP_FE425
#define MEMSIZE 16
#define  F4xx
#include  <msp430xE42x>
#endif

#ifdef CHIP_F155
#define MEMSIZE 8
#define F1xx
#include  <msp430x15x>
#endif

#ifdef CHIP_F133
#define MEMSIZE 8
#define F1xx
#include  <msp430x13x>
#endif

#ifdef CHIP_FE423
#define MEMSIZE 8
#define  F4xx
#include  <msp430xe42x>
#endif

#ifdef CHIP_F423
#define MEMSIZE 8
#define  F4xx
#include  <msp430x42x>
#endif

#ifdef CHIP_F123
#define MEMSIZE 8
#define F1xx
#include  <msp430x12x>
#endif

#ifdef CHIP_F1232
#define MEMSIZE 8
#define F1xx
#include  <msp430x12x2>
#endif

#ifdef CHIP_F122
#define MEMSIZE 4
#define F1xx
#include  <msp430x12x>
#endif

#ifdef CHIP_F1222
#define MEMSIZE 4
#define F1xx
#include  <msp430x12x2>
#endif

#if MEMSIZE==60
#define MEM_START  0x1100
#endif

#if MEMSIZE==55
#define MEM_START  0x2500
#endif

#if MEMSIZE==48
#define MEM_START  0x4000
#endif

#if MEMSIZE==32
#define MEM_START  0x8000
#endif

#if MEMSIZE==24
#define MEM_START  0xA000
#endif

#if MEMSIZE==16
#define MEM_START  0xC000
#endif

#if MEMSIZE==8
#define MEM_START  0xE000
#endif

#if MEMSIZE==4
#define MEM_START  0xF000
#endif


#ifndef  DIRECT_INTERRUPTS

#define MONITOR_START 0xFC00              //place monitor in Segments  0:1
#define UMEM_END    0xFBFF                //end of user flash
#define UMEM_START  MEM_START             //application at flash start
#define APP_START   0xFBFE

#else
  #if ((MEM_START/0x200)*0x200)< MEM_START // Segment n (the first flash
                                           // on some parts is only 256 bytes
  #define MONITOR_START (MEM_START+0x100)  // If this is one of those parts,
                                           // start the monitor on a 512-byt
                                           // segment boundary
  #else
  #define MONITOR_START  MEM_START         // Otherwise, put it in segs n-1:n
  #endif
#define UMEM_START  MEM_START+0x400
#define UMEM_END    0xFFFF
#define APP_START   0xFFFF

#endif

#define UMEM_SIZE   (UMEM_END-UMEM_START) //Size of user flash
#define NUM_SEGS    (((MEMSIZE*1024)/512)-2)

#ifdef  PASSWORD
  #define Password  (UMEM_END-33)
  // The application should put the 2-byte password just before
  // the application's vector table
#endif

#ifdef  F1xx
#define UART0_PORTSEL P3SEL
#define UART0_PORTDIR P3DIR
#define UART1_PORTSEL P3SEL
#define UART1_PORTDIR P3DIR
#define UTXD0 BIT4
#define URXD0 BIT5
#define UTXD1 BIT6
#define URXD1 BIT7
#endif

#ifdef  F4xx
#define UART0_PORTSEL P2SEL
#define UART0_PORTDIR P2DIR
#define UART1_PORTSEL P4SEL
#define UART1_PORTDIR P4DIR
#define UTXD0 BIT4
#define URXD0 BIT5
#define UTXD1 BIT0
#define URXD1 BIT1
#endif

#ifdef SERIAL_PORT_0

#define UART_PORTSEL  UART0_PORTSEL
#define UART_PORTDIR  UART0_PORTDIR
#define UTX         UTXD0
#define URX         URXD0
#define U_CTL       U0CTL
#define U_TCTL      U0TCTL
#define U_RCTL      U0RCTL
#define U_MCTL      U0MCTL
#define U_BR0       U0BR0
#define U_BR1       U0BR1
#define U_RXBUF     U0RXBUF
#define U_TXBUF     U0TXBUF
#define UART_ME     ME1
#define UART_IE     IE1
#define UART_TX_IFG UTXIFG0
#define UART_RX_IFG URXIFG0
#define UART_IFG    IFG1
#define UTXE_       UTXE0
#define URXE_       URXE0
#endif

#ifdef SERIAL_PORT_1

#define UART_PORTSEL  UART1_PORTSEL
#define UART_PORTDIR  UART1_PORTDIR
#define URX         URXD1
#define UTX         UTXD1
#define U_CTL       U1CTL
#define U_TCTL      U1TCTL
#define U_RCTL      U1RCTL
#define U_MCTL      U1MCTL
#define U_BR0       U1BR0
#define U_BR1       U1BR1
#define U_RXBUF     U1RXBUF
#define U_TXBUF     U1TXBUF
#define UART_ME     ME2
#define UART_IE     IE2
#define UART_TX_IFG UTXIFG1
#define UART_RX_IFG URXIFG1
#define UART_IFG    IFG2
#define UTXE_       UTXE1
#define URXE_       URXE1

#endif

